#!/usr/bin/perl
#
# usage:
#    listword.pl base_dir > m_word.new
# [to produce a new m_word.txt file]
# [comments rae output on the stderr]
#
#    listword.pl > /dev/null
# [to discard the output]
#

$basedir  = $ARGV[0] ||
  die "Usage: listword.pl base_dir > new_word_file";

$baseword = "$basedir/m_word.txt";
if (! $baseword ) {
  $baseword = "$basedir/util/m_word.txt";
}

if (! $baseword ) {
  die "No reference m_word.txt file found.";
}


for ($i=1; $i<=10; $i++) {
  $dir = "m_$i";
  print STDERR "entering $dir\n";
  chdir "$basedir/$dir";

  open( AAA, "grep VALUE *.htm |");
  while (<AAA>) {
    chop;
    # 
    # must FIX for the other uses of VALUE
    #
    next if ( ! /.*VALUE=\".*/);
    s/.*VALUE=\"(\w+)\".*/$1/g;
    push @words, $_;
  }
  close AAA;
} 
@sortlist = sort { $b cmp $a} @words;

print STDERR "\nProcessing m_word.txt \n";
print STDERR "The following words have not been found: \n";

open (BBB, "$baseword");
$refline = <BBB>;
($refword, $rest) = split(/ /, $refline, 2);

$lastword = "";
while ( $word = pop(@sortlist) ) { 
  next if ($word eq $lastword);
  while ($word gt $refword) {
    print $refline;
    if ( $refline = <BBB> ) {
      ($refword, $rest) = split(/ /, $refline, 2);
    } else {
      $refword = "zzzzz";
    }
  } 
  if ($word lt $refword) {
    print "$word\n";
    print STDERR "$word\n";
  }
  $lastword = $word;
}
if ($refline) {
  print $refline;
  while (<BBB>) {
    print;
  }
}
close BBB;
